package dev.shadowsoffire.apotheosis.spawn.modifiers;

package .var.folders._j.vfbv187d0bb8b8w5spzgg8180000gn.T;

import com.mojang.datafixers.kinds.App;
import com.mojang.datafixers.kinds.Applicative;
import com.mojang.serialization.Codec;
import com.mojang.serialization.codecs.RecordCodecBuilder;
import dev.shadowsoffire.apotheosis.spawn.modifiers.SpawnerStat;
import dev.shadowsoffire.apotheosis.spawn.modifiers.SpawnerStats;
import dev.shadowsoffire.apotheosis.spawn.modifiers.StatModifier;
import dev.shadowsoffire.apotheosis.spawn.spawner.ApothSpawnerBlock;
import dev.shadowsoffire.apotheosis.spawn.spawner.ApothSpawnerTile;
import java.util.function.BiConsumer;
import java.util.function.Function;
import net.minecraft.network.chat.Component;
import net.minecraft.util.Mth;

class ShortStat extends SpawnerStats.Base<Short> {
  public static final Codec<Short> BOUNDS_CODEC = Codec.intRange(-1, 32767).xmap(Integer::shortValue, Short::intValue);
  
  private final Codec<StatModifier<Short>> modifierCodec;
  
  private ShortStat(String id, Function<ApothSpawnerTile, Integer> getter, BiConsumer<ApothSpawnerTile, Short> setter) {
    super(id, tile -> Short.valueOf(((Integer)getter.apply(tile)).shortValue()), setter);
    this.modifierCodec = RecordCodecBuilder.create(inst -> inst.group((App)Codec.SHORT.fieldOf("value").forGetter(StatModifier::value), (App)BOUNDS_CODEC.fieldOf("min").forGetter(StatModifier::min), (App)BOUNDS_CODEC.fieldOf("max").forGetter(StatModifier::max)).apply((Applicative)inst, ()));
  }
  
  public Codec<StatModifier<Short>> getModifierCodec() {
    return this.modifierCodec;
  }
  
  public Component getTooltip(ApothSpawnerTile spawner) {
    return ApothSpawnerBlock.concat(new Object[] { name(), getValue(spawner) });
  }
  
  public boolean apply(Short value, Short min, Short max, ApothSpawnerTile spawner) {
    int old = ((Short)this.getter.apply(spawner)).shortValue();
    this.setter.accept(spawner, Short.valueOf((short)Mth.m_14045_(old + value.shortValue(), min.shortValue(), max.shortValue())));
    return (old != ((Short)this.getter.apply(spawner)).shortValue());
  }
}
